﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Collections.ObjectModel;

namespace XamDataCardsButtonInHeader
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                if (i % 2 == 0)
                {
                    Data.Add(new Data { ID = i, Name = "Name " + i, Status = "down" });
                }
                else
                {
                    Data.Add(new Data { ID = i, Name = "Name " + i , Status = "up" });
                }
                
            }

            DataContext = this;
        }

        public ObservableCollection<Data> Data { get; set; }

        void CardHeader_Loaded(object sender, RoutedEventArgs e)
        {
            Border border = Utilities.GetDescendantFromName((sender as CardHeaderPresenter), "Bd") as Border;
            Grid container = border.Child as Grid;
            
            Button btn = new Button { Width = 50};
            Grid.SetColumn(btn,1);

            container.Children.Add(btn);

            CardViewCard card = Utilities.GetAncestorFromType(sender as CardHeaderPresenter, typeof(CardViewCard), true) as CardViewCard;
            Rectangle rect = Utilities.GetDescendantFromName((sender as CardHeaderPresenter).Card, "outerBd") as Rectangle;
            if (card != null)
            {
                Binding contentBinding = new Binding();
                contentBinding.Source = ((card.Content as RecordPresenter).Record as DataRecord).Cells["Name"];
                contentBinding.Path = new PropertyPath("Value");
                btn.SetBinding(Button.ContentProperty, contentBinding);               
            }
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public string Status { get; set; }
    }
}
